<!--
Copyright © Institut für Qualitätsentwicklung an Schulen Schleswig-Holstein (IQSH)

SPDX-License-Identifier: AGPL-3.0-or-later
-->
<script setup lang="ts">
import { computed, toRef, ref, watch } from 'vue';
const props = defineProps<{
    modelValue?: string,
    valid?: boolean,
    strong?: boolean,
    label?: string,
    errorText?: string,
    mandatory?: string
}>();

const { strong, label, errorText } = props;

const modelValue = toRef(props, 'modelValue');
const password = toRef(props, 'modelValue');
const valid = toRef(props, 'valid');

const emits = defineEmits(['update:valid', 'update:modelValue']);

const passwordFieldType = ref('Password');

const seePassword = () => {
    passwordFieldType.value = passwordFieldType.value === 'Password' ? 'Text' : 'Password';
};

const validStrongPassword = (password: string) => {
    const regexp = new RegExp("^(?=[0-9a-zA-Z!\\-@#\\$%\\^&*]{8,}$)(?=.*?[a-z])(?=.*?[0-9])(?=.*?[A-Z])(?=.*?[!\\-@#\\$%\\^&*]).*");
    return regexp.test(password);
};

const validPassword = (password: string) => {
    const regexp = new RegExp("^(?=[0-9a-zA-Z!\-@#\$%\^&*]{6,}$)(?=.*?([a-z]||[A-Z]))(?=.*?[0-9]).*");
    return regexp.test(password);
};

const localPassword = computed({
    get: () => modelValue.value,
    set: (value) => emits(`update:modelValue`, value)
});

watch(localPassword, (newPassword, oldPassword) => {
    if (oldPassword !== undefined && newPassword !== undefined && oldPassword.length > 0 && newPassword.length === 0) {
        valid.value = true;
        emits(`update:valid`, true);
    } else {
        let passwordValid = true;
        if (strong)
            passwordValid = validStrongPassword(password.value!);
        else
            passwordValid = validPassword(password.value!);
        emits(`update:valid`, passwordValid)
    }
});

</script>
<template>
    <div class="mb-2 w-full px-0.5">
        <label v-if="label">{{ label }} <span class="text-orange-400" v-if="mandatory && mandatory === 'true'">-
                {{ $t('general.variables.mandatory') }}</span><span
                v-else-if="mandatory !== undefined && mandatory !== null && mandatory === 'false'">-
                {{ $t('general.variables.optional') }}</span></label>
        <div class="w-full flex flex-row outline outline-1 outline-gray-300 text-gray-500 rounded-md focus-within:outline-accent1-default h-8"
            :class="[{ 'border-red-700 focus-within:border-red-600 text-red-700  bg-red-500/20': !valid }]">
            <div class="px-2 pointer-events-none select-none"><i
                    class="ri-lock-line ri-1x items-center justify-center leading-8"></i></div>
            <input
                class="rounded-md px-2 w-full focus-visible:outline focus-visible:outline-0 focus:outline-0  h-8 bg-transparent placeholder:select-none"
                id="search" :type="passwordFieldType" name="password_search" v-model="localPassword"
                :placeholder="label" required>
            <div class="pointer-events-auto cursor-pointer px-2 select-none" @click="seePassword"><i
                    class="justify-center items-center cursor-pointer ri-1x leading-8"
                    :class="[{ 'ri-eye-line': passwordFieldType == 'Password' }, { 'ri-eye-off-line': passwordFieldType !== 'Password' }]"></i>
            </div>
        </div>
        <input :placeholder="label" type="Password" class="hidden">
        <span class="text-red-700 w-[350px]" v-if="!valid" v-html="errorText"></span>
    </div>
</template>